/**************************************************************** 
 * Description: 图的遍历
 * Author: Alex Li
 * Date: 2024-08-19 21:40:01
 * LastEditTime: 2024-08-19 21:40:06
****************************************************************/
#include<bits/stdc++.h>
using namespace std;
int n,t;
vector<int>mp[1005];
bool flag[1005];
void dfs(int now){
	for(int i=0;i<mp[now].size();i++){//子节点
		if(!flag[mp[now][i]]){
			flag[mp[now][i]]=true;//标为已走过
			dfs(mp[now][i]);//下一层
		}
	}
}
int main(){
	cin>>n>>t;//点数and边数
	for(int i=1;i<=t;i++){
		int u,v;
		cin>>u>>v;
		mp[u].push_back(v);//注意是有向图
	}
	for(int i=1;i<=n;i++){//dfs每个起始点
		flag[i]=true;
		dfs(i);	
		int ans=-1;
		for(int j=1;j<=n;j++){
			if(flag[j])ans=j;
		}
		cout<<ans<<' ';
		memset(flag,0,sizeof(flag));//多测不清空，爆零两行泪
	}
	return 0;
}